<?php

namespace BitCommunism\Twig;


use DI\Container;
use function DI\add;
use function DI\factory;
use function DI\get;
use function DI\object;
use function DI\string;

return [
    'twig.paths' => add([
        string('{basedir}/templates'),
        __DIR__ . '/../templates',
    ]),

    'twig.filtered_paths' => factory(function (Container $c) {
        $paths = $c->get('twig.paths');
        return array_filter($paths, 'is_dir');
    }),

    'twig.globals' => add([]),
    'twig.loader' => get(\Twig_Loader_Filesystem::class),
    'twig.debug' => false,
    'twig' => get(\Twig_Environment::class),

    \Twig_Loader_Filesystem::class => object(\Twig_Loader_Filesystem::class)
        ->constructorParameter('paths', get('twig.filtered_paths')),

    \Twig_LoaderInterface::class => get('twig.loader'),
];