<?php
/**
 * Created by PhpStorm.
 * User: eater
 * Date: 1/16/18
 * Time: 5:25 PM
 */

namespace BitCommunism\Twig\Handler;


use BitCommunism\Http\Handler;
use BitCommunism\Twig\Psr7\TwigStream;
use DI\Container;
use Twig\Environment;

class Twig extends Handler
{
    protected $environment;
    protected $templateVariables = [];

    public function __construct(Environment $environment, Container $container)
    {
        $this->environment = $environment;
        parent::__construct($container);
    }

    public function setTemplateVariable($key, $value) {
        $this->templateVariables[$key] = $value;
    }

    public function appendTemplateVariables($variables) {
        $this->templateVariables = array_merge($this->templateVariables, $variables);
    }

    public function template($template, $variables = [], $useGlobalVariables = true) {
        $stream = new TwigStream($this->environment);
        $stream->setTemplate($template);

        if ($useGlobalVariables) {
            $stream->appendVariables($this->container->get('twig.globals'));
        }

        $stream->appendVariables($this->templateVariables);
        $stream->appendVariables($variables);

        return $stream;
    }
}